// wavefortran.h 
// 
// Interfaces for FORTRAN calls

// Prototyping for FORTRAN routine readdata 
#define f_readinput FORTRAN_NAME(readinput_, READINPUT, readinput)

extern "C" {
  void f_readinput(INTEGER *,INTEGER *, DOUBLE *, DOUBLE *, DOUBLE *, DOUBLE *,
                   DOUBLE *,
                   INTEGER *, INTEGER *, DOUBLE *, INTEGER *, DOUBLE *,
                   INTEGER *, INTEGER *, INTEGER *);
}

// Prototyping for FORTRAN routine initial
#define f_initial_data FORTRAN_NAME(initial_, INITIAL, initial)

extern "C" {
  void f_initial_data(BI,FDI(DOUBLE));
}

// Prototyping for FORTRAN routine update
#define f_update FORTRAN_NAME(update_, UPDATE, update)

extern "C" {
  void f_update(BI,FDI(DOUBLE),FDI(DOUBLE),FDI(DOUBLE),FDI(DOUBLE),DOUBLE *, DOUBLE *);
}

// Prototyping for FORTRAN routine update_boundary
#define f_update_boundary FORTRAN_NAME(update_boundary_, UPDATE_BOUNDARY, update_boundary)

extern "C" {
  void f_update_boundary(BI,FDI(DOUBLE),FDI(DOUBLE),FDI(DOUBLE),FDI(DOUBLE),DOUBLE *, DOUBLE *);
}

#define f_restrict_amr FORTRAN_NAME(restrict2d2_, RESTRICT2D2, restrict2d2)
extern "C"
{
  void f_restrict_amr (FI(DOUBLE), FI(DOUBLE), BI, DOUBLE, INTEGER);
}

#define f_prolong_amr FORTRAN_NAME(prolong2d2_, PROLONG2D2, prolong2d2)
extern "C"
{
  void f_prolong_amr (FI(DOUBLE), FI(DOUBLE), BI, DOUBLE *, INTEGER *);
}

#define f_pythnorm FORTRAN_NAME(pythnorm_, PYTHNORM, pythnorm)
extern "C"
{
  void f_pythnorm(BI, FDI(DOUBLE), FDI(DOUBLE),
        	  DOUBLE *);
}
